
package de.ivu.elect.presentation.benutzerverwaltung.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerImporter;
import de.ivu.elect.business.benutzerverwaltung.control.BenutzerExchangeContext;
import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.datei.entity.DateiImportBerichtCustomData;
import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportSearchView;
import de.ivu.elect.presentation.exchange.ImportDescription;

@Named(BenutzerImportSearchView.COMPONENT_NAME)
@View(viewId = BenutzerImportSearchView.VIEW_ID, useCase = UseCasePermission.BENUTZER_IMPORTIEREN)
public class BenutzerImportSearchView extends AbstractImportSearchView<List<Benutzer>, BenutzerExchangeContext> {

  public static final String COMPONENT_NAME = "benutzerImportSearchView";

  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-import-search.xhtml";

  @Inject
  private BenutzerImporter benutzerImporter;

  @Inject
  private BenutzerImportDescription benutzerImportDescription;

  public BenutzerImportSearchView() {
    super();
  }

  @Override
  protected ImportDescription getImportDescription() {
    return benutzerImportDescription;
  }

  @Override
  protected AbstractImporter<List<Benutzer>, BenutzerExchangeContext, ? > getImporter() {
    return benutzerImporter;
  }

  @Override
  protected BenutzerExchangeContext getContext() {
    return new BenutzerExchangeContext(getMandant(), getBenutzer(), false);
  }

  @Override
  protected DateiImportBerichtCustomData createNewDateiImportBerichtCustomData() {
    return new DateiImportBerichtCustomData();
  }
}
